# -*- coding: utf-8 -*-
"""

bad_code.py re-written into useful, debuggable, testable, re-usable Python code.

@author: bgregor
"""

# Imports at the top
import random
import math


def median(x):
    ''' Calculate the median of x'''
    sorted_x = sorted(x)
    # if length 1 just return
    len_x = len(x)
    if len_x == 0:
        return None
    elif len_x == 1:
        return x[0]
    # If the length is odd, pick the middle value
    elif len(x) % 2 != 0:
        idx = int(len(x)/2) + 1
        return sorted_x[idx]
     # Otherwise...x length is even. Return the average of 
     # the two middlemost values.
    idx_r = int(len(x)/2)
    idx_l = idx_r - 1
    val = (sorted_x[idx_l] + sorted_x[idx_r]) / 2 
    return val


def mean(x):
    ''' Calculate the mean of x '''
    sum_x = sum(x)
    val = sum_x / len(x)
    return val

def std_dev_sqrd_sum(x):
    ''' Calculate the sum of the squares of the 
        difference from the mean for the elements of x'''
    # get the mean
    mean_x = mean(x)
    # subtract from each element, square, and sum
    sqrd_sum = sum([(elem - mean_x)**2 for elem in x])
    return sqrd_sum

def pop_std_dev(x):
    ''' Calculate the population standard deviation of x
        That's the squard sum of diff. from the mean divided by N'''
    sqrd_sum = std_dev_sqrd_sum(x)
    # Divide by N
    val = sqrd_sum / len(x)
    # return the square root
    return math.sqrt(val)

def std_dev(x):
    ''' Calculate the standard deviation of x
        That's the squard sum of diff. from the mean divided by N-1'''
    sqrd_sum = std_dev_sqrd_sum(x)
    # divide by N-1 and return the square root
    return math.sqrt(sqrd_sum / (len(x)-1))


if __name__=='__main__':
    ''' Run if called as a script '''
    # Get some random numbers
    N = 10000
    rand_nums = [random.random() for x in range(N)]
    
    # Compute some stats and print the results
    print('%s values randomly generated.' % N)
    print('median: %s' % median(rand_nums))
    print('mean: %s' % mean(rand_nums))
    print('standard deviation: %s' % std_dev(rand_nums))
    print('population standard deviation: %s' % pop_std_dev(rand_nums))

 
