# -*- coding: utf-8 -*-
"""
Created on Wed May 16 13:37:00 2018

Examples of various ways to use for loops

@author: bgregor
"""

# Define a list
my_pets = ['cat','dog',
           'parakeet','komodo dragon']
#
#
# Use a for loop to access each element in turn
print('Loop 1')
for pet in my_pets:
    if len(pet) > 8:
        print('My favorite pet: %s' % pet)
    else:
        print(pet)
        
# The reference variable just holds the location
# of the list element. Re-assigning it does NOT
# change the list.
print('Loop 2')

for pet in my_pets:
    pet = -1000

# unchanged list.
print(my_pets)


#Now access by index.  The range() function
#will generate index values.  With the index
# the original list CAN be updated as index values
# can access the list normally.
print('Loop 3')
for idx in range(len(my_pets)):
    print(my_pets[idx])
    my_pets[idx] = my_pets[idx].capitalize()    
print(my_pets)

#What if you want to access by index and by 
#a reference name at the same time?  Use the 
# enumerate() function
print('Loop 4')
for idx,pet in enumerate(my_pets):
    my_pets[idx] = pet.lower()
  
# Finally - the list comprehension. Here make a new 
# list from an existing list with implicit for-looping
print('List comprehension')
capital_pets = [pet.upper() for pet in my_pets]
print(capital_pets)










