# -*- coding: utf-8 -*-
"""
Some basics of numpy

@author: bgregor
"""


# The usual convention
import numpy as np

# Create a vector, i.e. a rank 1 array
a = np.array([10, 20, 30])   
# a.shape returns a tuple of the array dimensions
print(a.shape)            
# Index like a list 
print(a[0], a[1], a[2]) 
# Change an element of the array
a[0] = -5             
# Prints like a list
print(a)                  

# Create a 2D matrix, i.e. a rank 2 array
b = np.array([[10,20,30],[40,50,60]])    
print(b.shape)
# Note the indexing has changed:  [row,col]
print(b[0, 0], b[0, 1], b[1, 0])    

# Some very Matlab-like functions exist to create
# arrays
# Create an array of all zeros
zeros = np.zeros((2,2))   
print(zeros)              

# an array of all 1's
ones = np.ones((3,2,4))
# What do you think it'll print?     
print(b)            
 
# The identity matrix
ident = np.eye(3)        
print(ident)         

# An array of random numbers uniformly
# distributed between 0 and 1
ran_nums = np.random.random([3,4])
print(ran_nums)

   