# -*- coding: utf-8 -*-
"""

Alternate solution that shows how to read larger files without
as much memory usage.
@author: bgregor
"""

# We'll need a function to determine if a number is 
# even or odd.
def is_even(x):
    ''' x is even if there is no remainder
        when it is divided by 2'''
    return (x % 2)==0


# Create odd and even lists
odds=[]
evens=[]

with open('numbers.txt','r') as f:
    # Loop over the open file as if it were a list.
    # Python will automatically read it line-by-line
    # which each line read as a string.
    for line in f:
        str_vals = line.split(',')
        # str_vals -->  ['64','16','95','79','23']
        # Loop again and convert each one to an int, test, and store
        # Note this is independent of the number of values in the line!
        for one_str in str_vals:
            int_val = int(one_str) # int() is a built-in Python function.
            if is_even(int_val):
                evens.append(int_val)
            else:
                odds.append(int_val)

# And that's it! 
print('Number of even values: %s' % (len(evens),))
print('Number of odd values: %s' % (len(odds),))

# Now do some math....what's the average of each?
avg_evens = sum(evens) / len(evens)
avg_odds = sum(evens) / len(odds)
print('Averages.  evens: %s   odds: %s' % (avg_evens,avg_odds))
